routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CompanieController;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\Auth\SocialiteController;
use App\Http\Controllers\ItemController;
use App\Http\Controllers\SellController;
use App\Http\Controllers\SellSummaryController;
use App\Jobs\SendEmailJob;
use Illuminate\Support\Facades\Auth;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Auth::routes([
    'register' => false
]);

Route::get('/auth/redirect/{provider}',[SocialiteController::class,'redirect'])->name('auth.redirect');
Route::get('/auth/callback/{provider}',[SocialiteController::class,'callback'])->name('auth.callback');

Route::middleware('auth')->group(function(){
    
    Route::get('lang/{lang}', ['as' => 'lang.switch', 'uses' => App\Http\Controllers\LanguageController::class,'switch']);

    Route::get('/', function () {
        return view('home');
    });

    Route::get('tz/{tz}', ['as' => 'tz.switch', 'uses' => App\Http\Controllers\TimezoneController::class,'switch']);

    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('employees',EmployeeController::class)->except(['destroy']);
    Route::resource('sells',SellController::class)->except(['destroy']);
    Route::get('/employees/{employee}/destroy',[EmployeeController::class,'destroy'])->name('employees.destroy');
    
    Route::resource('companies',CompanieController::class)->except(['destroy']);
    Route::resource('items',ItemController::class)->except(['destroy']);
    Route::resource('sellSummaries',SellSummaryController::class)->except(['destroy']);
    Route::get('/items/{item}/destroy',[ItemController::class,'destroy'])->name('items.destroy');
    Route::get('/sells/{sell}/destroy',[SellController::class,'destroy'])->name('sells.destroy');

    Route::get('/companies/{company}/destroy',[CompanieController::class,'destroy'])->name('companies.destroy');
    
    Route::get('test/email', function(){
        $send_mail = 'lim.liete@gmail.com';
        dispatch(new App\Jobs\SendEmailJob($send_mail));
        dd('send mail successfully !!');
    })->name('sendEmail');
    

    

});

app/Models/Item.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Item extends Model
{
    use HasFactory;

    protected $fillable = [
        'name',
        'price'
    ];

    
}

app/Http/Controllers/ItemController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\ItemStoreRequest;
use App\Models\Item;
use Illuminate\Http\Request;

class ItemController extends Controller
{




    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        
        return view('item.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('item.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ItemStoreRequest $request)
    {

    
        Item::create([
            'name' => $request->name,
            'price' => $request->price
        ]);

        return redirect()->route('items.create')->with('message',['text' => __('item.status2'), 'class' => 'success']);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit(Item $item)
    {
        return view('item.edit',compact('item'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(ItemStoreRequest $request, Item $item)
    {


        $item->update([
            'name' => $request->name,
            'price' => $request->price
        ]);

        return redirect()->route('items.edit',$item->id)->with('message',['text' => __('item.status3'), 'class' => 'success']);

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Item $item)
    {
        $item->delete();
        return redirect()->route('items.index')->with('message',['text' => __('item.status4'), 'class' => 'success']);
    }
}

app/View/Components/Items.php
<?php

namespace App\View\Components;

use App\Models\Item;
use Illuminate\View\Component;

class Items extends Component
{
    /**
     * Create a new component instance.
     *
     * @return void
     */
    public function __construct()
    {
        //
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\Contracts\View\View|\Closure|string
     */
    public function render()
    {
        $items = Item::count();
        return view('components.items',compact('items'));
    }
}

resources/views/item/create.blade.php
@extends('layouts.app')
@section('title')
{{trans('item.title2') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

        @include('layouts.notif')

        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                {{trans('item.title2') }}
                    <a href="{{ route('items.index') }}" class="btn btn-sm btn-secondary float-right">{{trans('item.btn4') }}</a>
                </div>
                <div class="card-body">
                    <form action="{{ route('items.store') }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        <div class="row">
                            <div class="col-6">
                                <label for="">{{trans('item.table1') }}</label>
                                <input type="text" class="form-control" name="name" value="{{ old('name') }}">
                                @include('layouts.error', ['name' => 'name'])
                            </div>
                            <div class="col-6">
                                <label for="">{{trans('item.table2') }}</label>
                                <input type="text" class="form-control" name="price" value="{{ old('price') }}">
                                @include('layouts.error', ['name' => 'price'])
                            </div>
                        </div>
                        <div class="row p-3">
                            <button class="btn btn-primary btn-block" type="submit">{{trans('item.btn1') }}</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/item/edit.blade.php
@extends('layouts.app')
@section('title')
{{trans('item.title3') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

        @include('layouts.notif')

        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                {{trans('item.title3') }}
                    <a href="{{ route('items.index') }}" class="btn btn-sm btn-secondary float-right">{{trans('item.btn4') }}</a>
                </div>
                <div class="card-body">
                    <form action="{{ route('items.update',$item->id) }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        @method('PUT')
                        <div class="row">
                            <div class="col-6">
                                <label for=""> {{trans('item.table1') }}</label>
                                <input type="text" class="form-control" name="name" value="{{ $item->name }}">
                                @include('layouts.error', ['name' => 'name'])
                            </div>
                            <div class="col-6">
                                <label for=""> {{trans('item.table2') }}</label>
                                <input type="number" class="form-control" name="price" value="{{ $item->price }}">
                                @include('layouts.error', ['name' => 'price'])
                            </div>
                        </div>
                        <div class="row mt-3">
                            <div class="col-6 " style="display: none;">
                                <label for="">{{ __('Created By Id') }}</label>
                                <div class="mt-2">
                                    <input type="text" name="created_by_id" class="form-control" value="{{ $item->created_by_id }}">
                                    @include('layouts.error', ['name' => 'created_by_id'])
                                </div>
                            </div>
                            <div class="col-6 " style="display: none;">
                                <label for="">{{ __('Updated By Id') }}</label>
                                <div class="mt-2">
                                    <input type="text" name="updated_by_id" class="form-control" value="{{ Auth::id() }}">
                                    @include('layouts.error', ['name' => 'updated_by_id'])
                                </div>
                            </div>
                        </div>
                        <div class="row p-3">
                            <button class="btn btn-primary btn-block" type="submit"> {{trans('item.btn5') }}</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/item/index.blade.php
@extends('layouts.app')
@section('title')
{{trans('item.title1') }}
@endsection
@section('content')
<div class="container">
    <div class="row justify-content-center">

        @include('layouts.notif')

        <div class="col-md-12 mt-2">
            <div class="card">
                <div class="card-header">
                {{trans('item.title1') }}
                    <a href="{{ route('items.create') }}" class="btn btn-sm btn-primary float-right">{{trans('item.btn1') }}</a>
                </div>
                <div class="card-body">
                    <br>
                    <!-- MULAI DATE RANGE PICKER -->
                    <div class="row input-daterange">
                        <div class="col-md-6">
                            <input type="text" name="from_date" id="from_date" class="form-control" placeholder="{{trans('item.fromdate') }}" readonly />
                        </div>
                        <div class="col-md-6">
                            <input type="text" name="to_date" id="to_date" class="form-control" placeholder="{{trans('item.todate') }}" readonly />
                        </div>
                        
                    </div>
                    <!-- AKHIR DATE RANGE PICKER -->
                    <br>
                <div class="row">
                        <div class="col-md-6">
                            <input type="text"   class="form-control filter-input" id="name" name="name" placeholder="{{trans('item.filtername') }}" data-column="1"/>
                        </div>
                        <div class="col-md-6">
                            <input type="number"   class="form-control filter-input" id="price" name="price" placeholder="{{trans('item.filterprice') }}" data-column="2"/>
                        </div>
                
                    </div> 
                    <br>
                    <div class="row">
                        <div class="col-md" style="text-align: end">
                            <button type="button" name="filter" id="filter" class="btn btn-primary">{{trans('item.btn6') }}</button>
                            <button type="button" name="refresh" id="refresh" class="btn btn-default">{{trans('item.btn7') }}</button>
                        </div>
                    </div>
                    
                    <br>
                    <table class="table text-center table-bordered table-striped" id="ItemsTable">
                        <thead>
                            <tr>
                                <th>#</th>
                                <th> {{trans('item.table1') }} </th>
                                <th> {{trans('item.table2') }} </th>
                                <th> {{trans('item.table3') }} </th>
                                <th> {{trans('item.table4') }} </th>
                                <th> {{trans('item.table5') }} </th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>



    </div>
</div>
@endsection
@section('script')
<!-- MULAI DATEPICKER JS -->
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/css/bootstrap-datepicker.min.css">

<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/js/bootstrap-datepicker.js"></script>
<script type="text/javascript">
    $(document).ready(function() {
        $.noConflict();
        var table = $('#ItemsTable').DataTable({
            "processing": true,
            "serverSide": true,
            "dom"       : "lrtpi",
            "responsive": true,
            ajax: {
                url: "{{ route('api.items') }}",
                type: 'GET',
                data: {
                    region:  "{{ Session::get('tz') }}"
                } //jangan lupa kirim parameter tanggal 
            },
            "columns": [{
                    "data": "DT_RowIndex",
                    name: 'DT_RowIndex'
                },
                {
                    "data": "name"
                },
                {
                    "data": "price"
                },
                {
                    "data": "created_at"
                },
                {
                    "data": "updated_at"
                },
                {
                    "data": "action",
                    name: 'action',
                    orderable: false,
                    searchable: false
                }
            ]
        });
    //     $('.filter-input').keyup(function() {
    //     table.column( $(this).data('column') )
    //     .search( $(this).val() )
    //     .draw();
    // });
    });
    
</script>
<script>


    //jalankan function load_data diawal agar data ter-load
    // load_data();
    //Iniliasi datepicker pada class input
    $('.input-daterange').datepicker({
        todayBtn: 'linked',
        format: 'yyyy-mm-dd',
        autoclose: true
    });
    $('#filter').click(function() {
        var from_date = $('#from_date').val();
        var to_date = $('#to_date').val();
        var name = $('#name').val();
        var price = $('#price').val();
        if (from_date != '' && to_date != '') {
            $('#ItemsTable').DataTable().destroy();
            load_data(from_date, to_date,name,price);
        } else {
            $('#ItemsTable').DataTable().destroy();
            load_data('', '',name,price);
        }
    });
    $('#refresh').click(function() {
        $('#from_date').val('');
        $('#to_date').val('');
        $('#name').val('');
        $('#price').val('');
        $('#ItemsTable').DataTable().destroy();
        load_data();
    });



    function load_data(from_date = '', to_date = '', name = '', price = '') {
        var table =$('#ItemsTable').DataTable({
            "processing": true,
            "dom"       : "lrtpi",
            "serverSide": true,
            "responsive": true,
            ajax: {
                url: "{{ route('api.items') }}",
                type: 'GET',
                data: {
                    from_date: from_date,
                    to_date: to_date,
                    name: name,
                    price: price,
                    region:  "{{ Session::get('tz') }}"
                } //jangan lupa kirim parameter tanggal 
            },
            "columns": [{
                    "data": "DT_RowIndex",
                    name: 'DT_RowIndex'
                },
                {
                    "data": "name"
                },
                {
                    "data": "price"
                },
                {
                    "data": "created_at"
                },
                {
                    "data": "updated_at"
                },
                {
                    "data": "action",
                    name: 'action',
                    orderable: false,
                    searchable: false
                }
            ]
            
        });
    //     $('.filter-input').keyup(function() {
    //     table.column( $(this).data('column') )
    //     .search( $(this).val() )
    //     .draw();
    // });
    };
</script>
@endsection